%% I fucking hate this chapter. Is the most difficult writing wise.

\chapter{Introduction}

In this work I have applied an existing technique known as CHABADA to
a large dataset of Android applications. This technique, which is
explained thoroughly later in this book, searches for correlations between the API usage in the application binary and the natural language description that is shown to the users in the Google Play Store. In order to be able to apply the technique to a large dataset of Android application I have had to refactor several parts of the implementation and add new modules to the system.

%% Some of the modifications that I have done are changing the datastore from a filesystem to a document database and refactoring the code to allow horizontal scalability. Regarding the extensions, I have implemented modules to obtain data from the dataset and improvements in the deployment of the system to facilitate the execution of the cloud.

\section{The Android application ecosystem}

Android is the dominant operating system in the mobile devices market and had roughly 88\% of market share in 2016 \cite{AndroidG91:online}. Users of the Android operating system can install third party software in app stores. This app stores serve as a marketplace where developers can publish their software and users can install it. Most marketplaces allow the developers publish the applications for free or behind a paywall. Google Play, Google's marketplace for Android applications, is the default marketplace installed in most of today's Android devices. In this marketplace the developers can write a description of the application capabilities and other information. There is, however, no automated way to know if this descriptions are accurate or honest; developers could be accessing information that is not related to the functionality of the application or the description could promise some features that aren't actually implemented. The manual way of inspecting an application also requires high technical expertise in Android applications, reverse engineering and analysis. In summary, there's no simple way for the average user to actually know if the software they are installing in their devices is a trustworthy software.

\section{Scope}

The goal of this project is to apply the existing technique of CHABADA to the Tacyt dataset. However, the existing implementation have scalability limitations that make running the original implementation as is very complicated, if not impossible. The size of the dataset is two orders of magnitude larger that the size of the dataset used in the first iteration of CHABADA back in 2014.

\subsection{Tacyt}

Tacyt\cite{Tacyt65:online} is a large dataset of Android applications made by ElevenPaths, a Telefonica company. They have scraped the Google Play store among others to create this dataset and have approximately 5 million applications. Tacyt has a web panel where users can query the system to obtain information about applications. Some applications can also be downloaded from the web panel. ElevenPaths also offers a free software library to connect to Tacyt written in the Python programming language.

The query language that Tacyt offers to query the system has a lot of parameters available and is composable using the three basic boolean operators ($\wedge$, $\vee$ and $\neg$). However, the results that can be obtained from the queries is limited. The query language only admits up to 40 predicates in a query, and returns a maximum of one thousand results. This limitations are probably implemented to avoid abuse and large queries that can degrade the performance of the system or consume too much resources during transmission.

In the JNIC conference of 2017 ElevenPaths proposed to the research community to use this dataset and further expand the meaning of the dataset.

\subsection{CHABADA}

CHABADA\cite{chabada} is a technique developed by Gorla et al in 2014. The idea behind CHABADA is that is difficult to know whenever a certain application carries malicious code or not. For example, one could think that the ability to send SMS is out of place in a photo edition application, but is perfectly normal for a messaging application. By using a combination of natural language processing and clustering we can know what API usage is normal for a group of related applications. Once we have this information we can use outlier detection algorithms to find applications that use API calls that are not normal in the group. This applications could have a malicious intent or be poorly coded. To further know what's the actual intention of that abnormal API usage manual inspection is required.

\section{Document structure}

The rest of the document is structured as follows; first I explain the
current state of the art related to the Android application ecosystem
analysis. Following the state of the art I present an explanation of the CHABADA technique. After this I detail the changes that I have made to the implementation of CHABADA, and I finish with the obtained results and some conclusions.

%  LocalWords:  CHABADA dataset refactor paywall Tacyt scalability
%  LocalWords:  ElevenPaths Telefonica composable boolean JNIC SMS
%  LocalWords:  outlier
